unit list;
{ copyright : natwar lath nlath@kalinga.com
see accompanying readme.txt for more details}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Mask, ExtCtrls, Printers
  ;

type
  TfrmList = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Source: TEdit;
    Dest: TEdit;
    OpenDialog1: TOpenDialog;
    Shape1: TShape;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Bottom: TMaskEdit;
    Top: TMaskEdit;
    Label5: TLabel;
    Label6: TLabel;
    Left: TMaskEdit;
    Right: TMaskEdit;
    GroupBox2: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Length: TMaskEdit;
    Width: TMaskEdit;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    BitBtn4: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn3: TBitBtn;
    OfficeButton1: TBitBtn;
    Memo1: TMemo;
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure FileCopy ( FSrc, FDest : String);
  procedure FilePrint ( FSrc : String);
  procedure FileFormat ( FSrc, FDest : String);
  procedure NewPage;

var
  frmList: TfrmList;
  CurrLine : integer;
  CurrPage : integer;

Function Spaces(i:Byte):String;
Function Padl(inString: String; howmany: Integer) : String;
Function Replicate (chartodo : string ; NoOfTimes : integer) : string;

implementation

{$R *.DFM}

uses txtview;

procedure TfrmList.SpeedButton1Click(Sender: TObject);
begin
  with OpenDialog1 do
  if Execute then
  begin
    Source.text := Lowercase(FileName);
  end;
end;

procedure TfrmList.BitBtn1Click(Sender: TObject);
begin
while  (source.text = 'Source') do
   SpeedButton1Click(nil);


Application.CreateForm(TPreview, Preview);

with preview do
begin
    Memo1.Lines.LoadFromFile(Source.Text);
    Caption := 'Text File Previewer ' + Lowercase(Source.Text);
    showmodal;
end;

Preview.Free;

end;

procedure FileCopy ( FSrc, FDest : String);
var
   FileSource : TextFile;
   FileDest : System.Text;
   s : string;
begin
     AssignFile (FileSource, FSrc);
     AssignFile (FileDest, FDest);

     Reset(FileSource);
     Rewrite (FileDest);

     while not eof(filesource) do
     begin
          readln(FileSource, s);
          writeln (FileDest, s);
     end;
     closefile (FileSource);
     closefile (FileDest);
end;

procedure FilePrint ( FSrc : String);
var
   FileSource : TextFile;
   FileDest : System.Text;
   s : string;
begin
     AssignFile (FileSource, FSrc);
     AssignPrn (FileDest);

     Printer.Canvas.Font.Name:='Draft 10cpi';
     Reset(FileSource);
     Rewrite (FileDest);
     while not eof(filesource) do
     begin
          readln(FileSource, s);
          writeln (FileDest, s);
     end;
     closefile (FileSource);
     closefile (FileDest);
{     Printer.EndDoc;}
end;


procedure TfrmList.BitBtn3Click(Sender: TObject);
begin
     if Dest.Text = 'Destination' then
     begin
        raise exception.create ('You must enter a valid destination');
        exit
     end;
     if source.text = 'Source' then
        SpeedButton1Click(nil);
     FileCopy (Source.Text, Dest.Text);
end;

procedure TfrmList.BitBtn2Click(Sender: TObject);
begin
     if source.text = 'Source' then
        SpeedButton1Click(nil);
     FilePrint (Source.Text);
end;

procedure FileFormat ( FSrc, FDest : String);
var
   FileSource : TextFile;
   FileDest : System.Text;
   i : integer;
   s : string;
   PrintLines : integer;
   Left : integer;
   TxtWidth : integer;
   Footer : string;
   ActualWidth : integer;
begin
     PrintLines := strtoint(frmlist.Length.text) -
                   strtoint(frmlist.top.text) -
                   strtoint(frmlist.bottom.text);
     Left := strtoint (frmlist.left.text);
     CurrLine := 0;
     CurrPage := 0;
     ActualWidth := strtoint(frmlist.Width.text) -
                     strtoint(frmlist.left.text) -
                     strtoint(frmlist.right.text);

     TxtWidth := (ActualWidth -10) * (screen.width div 80);

     frmlist.memo1.width := TxtWidth;

     AssignFile (FileSource, FSrc);
     AssignFile (FileDest, FDest);

     Reset(FileSource);
     Rewrite (FileDest);

     Footer := Spaces (ActualWidth-3)+'Page : %4d '+ #12;

               if CurrPage = 0 then
             {Print header}
             begin
                  Writeln(FileDest, '');
                  writeln(FileDest, Padl (frmlist.source.text, Left) );
                  writeln(FileDest, Padl(Replicate('-', ActualWidth+4),Left));
                  Writeln(FileDest, '');
                  CurrLIne := CUrrLIne + 4;
                  while CurrLine < strtoint(frmlist.top.text) do
                  begin
                       Writeln(FileDest, '');
                       Inc(CurrLine);
                  end;
                  Inc(CurrPage);
             end;


     while not eof(filesource) do
     begin
          frmlist.memo1.lines.clear;
          readln(FileSource, s);
          frmlist.memo1.lines.add(s);
          If CurrLine = 0 then NewPage;
          for i := 1 to frmlist.memo1.lines.count do
          begin
               writeln(FileDest, Padl (frmlist.memo1.lines[i-1], Left) );
               Inc(CurrLine);
              IF CurrLine >= PrintLines then
                 begin
                      writeln(FileDest,'');
                      writeln(FileDest, Padl(Replicate('-', ActualWidth+4),Left));
                      writeln(FileDest, format(footer, [CurrPage]));
                      CurrLine := 0;

                      {print header}
                      Writeln(FileDest, '');
                      writeln(FileDest, Padl (frmlist.source.text, Left) );
                      writeln(FileDest, Padl(Replicate('-', ActualWidth+4),Left));
                      Writeln(FileDest, '');
                      CurrLIne := CUrrLIne + 4;
                      while CurrLine < strtoint(frmlist.top.text) do
                            begin
                              Writeln(FileDest, '');
                              Inc(CurrLine);
                            end;
                  Inc(CurrPage);
                 end;

          end
     end;
     IF CurrLine > 0 then
     begin
          writeln(FileDest,'');
          writeln(FileDest, Padl(Replicate('-', ActualWidth+4),Left));
          writeln(FileDest, format(footer, [CurrPage]));
          CurrLine := 0;
     end;

     closefile (FileSource);
     closefile (FileDest);
end;

procedure NewPage;
begin
If CurrPage > 0 then
   { print footer here }
   ;
end;




procedure TfrmList.BitBtn4Click(Sender: TObject);
begin
     if source.text = 'Source' then
        SpeedButton1Click(nil);
     FileFormat (Source.Text, Dest.Text);

end;

procedure TfrmList.BitBtn6Click(Sender: TObject);
begin
ShowMessage (' Lister by Natwar Lath - nlath@iname.com');
end;

procedure TfrmList.BitBtn5Click(Sender: TObject);
begin
close;
end;

Function Spaces;
Var
  zip : String[255];
Begin
  FillChar(zip,i+1,' ');
  zip[0] := Chr(i);
  Spaces := Zip;
End;

Function Padl;
Begin
  Insert(Spaces(howmany), inString, 1);
  PadL := inString;
End;


Function Replicate (chartodo : string ; NoOfTimes : integer) : string;
var
   i : integer;
   final : string;

begin
final := chartodo;
for i := 1 to NoOfTimes do
    final := chartodo + final;
result := final;
end;




end.
